require 'sub_zero'

Auditing = SubZero.client(:auditing)

# or

Auditing = SubZero.client :auditing do |c|
  c.timeout = 5000
  # what else? retry?
end

# fire and forget, just waits the Broker ACK to not care anymore, opens a thread
Auditing.log! author: 'Pedro Alvares Cabral', action: 'discovered Brazil.. heh.'

# waits for reply
ronconcon_logs = Auditing.index(author: 'Marques de Pombal')

# for more complex verbs, the base method call:

Auditing.call! 'bugs/report', error: 'error while trying to log'

Auditing.call 'stats/count'

Auditing.stats_count

# some sugar to sync call might be

Auditing['stats/count']


Auditing.stats! do |stats|
  DeveloperChatRoom.push "Availabilty: #{stats[:availability]}"
end


# reply:

# ACK:NOK { error: { message: '', code: '', … } } (BROKER)
# STATS/COUNT:OK
# STATS/COUNT:NOK { error: { message: '', code: '', … }}
# retry strategy

