require 'yaml'
require 'securerandom'
require 'timeout'
require 'digest/md5'

require 'thor'
require 'thor/group'

require 'active_support/string_inquirer'
require 'active_support/hash_with_indifferent_access'
require 'active_support/concern'
require 'active_support/core_ext/module/delegation'

require_relative 'sub_zero/version'
require_relative 'sub_zero/environment'
require_relative 'sub_zero/main'

module SubZero
  autoload :CLI,           'sub_zero/cli'
  autoload :Client,        'sub_zero/client'
  autoload :Configuration, 'sub_zero/configuration'
  autoload :Loggable,      'sub_zero/loggable'
  autoload :Message,       'sub_zero/message'
  autoload :Service,       'sub_zero/service'
  autoload :Socket,        'sub_zero/socket'
  extend   self
  extend   Environment

  def client service_id
    block_given? ? Client.new(service_id, &block) : Client.new(service_id)
  end

end
