module SubZero
  class Message
    module Validations

      def validate_response! request
        broker_reply  = type == 'BRO'
        service_reply = type == 'REP' && subtype == request.sid

        unless broker_reply || service_reply
          fail Socket::Error, "unexpected result type: #{type}, " +
                              "subtype: #{subtype}. " + to_s
        end

        unless rid == request.rid
          fail Socket::Error, "rid mismatch. sent: #{request.rid}, " +
                              "received: #{rid}. " + to_s
        end

        unless verb == request.verb && response?
          fail Socket::Error, "reply verb mismatch: #{verb}, " +
                              "status: #{status}. " + to_s
        end

        true
      end

    end
  end
end
