require_relative 'service/handler'
require_relative 'service/router'
require_relative 'service/runner'

module SubZero
  module Service
    include Router
    include Loggable
    include Runner

    def sid service_id = nil
      @sid = service_id.to_sym if service_id
      @sid
    end

    def resolve message
      if handler = routes[message.verb]
        handler[message]
      else
        # TODO verb mismatch error
      end
    end

    private

    def socket
      Socket.new
    end

  end
end
