SubZero is meant to be a way for us to dab into polyglot architectures.

SubZero itself is made up of 3 parts:

Broker
======

The traffic cop of the scheme. The Broker mediates requests between Services and Clients. Clients and Services cannot talk directly. Responsabilities:

- route messages between components
- know of active instances of certain Services
- have a TTL scheme to guess when components are down
- manage retries

Services
========

Services exchange messages with clients. When a service boots up, it must register with the Broker before accepting work.

Clients
=======

Cients send requests to the Broker for specific Service IDs (but not instances of Services).

Messages
--------

There are two types of messages: Broker to Client( or Service) and Client (or Service) to Broker. Since the Broker has a DEALER socket, all of its outgoing messages are prefixed with an ID.

Typical envelope:

<pre>
ID - string matching the ZMQ identity of a socket (only for outgoing messages from the Broker)
RID - UUID that is preserved on all messages pertaining to this request
TYPE and optionally SUBTYPE after ':' - examples:
  BRO (when Broker replies to PINGs from services)
  SRV (when Service boots up and announces itself)
  CLI:SID (Client asking for a Service reply)
  REQ:ID (Broker forwarding Client request to Service)
  SRV:ID (Service replying to Broker about client request)
  REP:SID (Broker forwards Service reply to Clent)
VERB - can be PING, PONG, UP, ACK, SORT, TAG, etc. Victor suggested subverbs and I agree or else we'll have huge verb handlers on all Services
PAYLOAD - a MessagePack serialized hash
</pre>


Intended flow for Service authoring
===================================

1. sub_zero new service X
2. cd X
3. edit config.yml to set broker options (URI, port, etc.)
4. add routes to verbs.rb
5. create class with handlers (subclass of SubZero::Handler ?)
6. when production-ready, run cap deploy to install it on /services (or whatever) in PRD
7. call /etc/init.d/sub_zero start X in PRD to start service

Variations: 
 - sub_zero new service X --lang=scala ? To use different file templates?

